(function ($, Drupal) {
  // source: https://stackoverflow.com/questions/5999118/how-can-i-add-or-update-a-query-string-parameter
  function updateQueryStringParameter(uri, key, value) {
    var re = new RegExp("([?&])" + key + "=.*?(&|$)", "i");
    var separator = uri.indexOf('?') !== -1 ? "&" : "?";
    if (uri.match(re)) {
      return uri.replace(re, '$1' + key + "=" + value + '$2');
    }
    else {
      return uri + separator + key + "=" + value;
    }
  }

  Drupal.behaviors.ajaxDashboard = {
    attach: function (context, settings) {
      $('.ajax-dashboard-button').click(function () {
        let content_url = $(this).data('content-url');
        let ajax_url = Drupal.url.toAbsolute(content_url);
        let button_id = $(this).data('button-id');
        qstring = updateQueryStringParameter(window.location.search, 'dashboard', button_id);
        u = window.location.pathname + qstring;
        history.pushState({}, "", u);
        // Now, set a cookie to remember the form someone looked at previously.
        document.cookie = 'ajax_dashboard__' + settings.ajax_dashboard.dashboard_id + "=" + button_id + ";path=/";
        Drupal.ajax({ url: ajax_url }).execute();
      });
    }
  };
})(jQuery, Drupal);
