<?php

namespace Drupal\ajax_dashboard\Plugin;

use Drupal\Component\Plugin\PluginBase;

/**
 * Base class for AJAX Dashboard Button plugins.
 */
abstract class AJAXDashboardButtonBase extends PluginBase implements AJAXDashboardButtonInterface {

  /**
   * @param array $params
   * @return bool
   */
  public static function access($params = [], $button_data = []) {
    return TRUE;
  }

  /**
   * @param array $params
   * @return string
   */
  public static function getButtonStatus($params = [], $button_data = []) {
    return 'neutral';
  }

  /**
   * @param array $params
   * @param array $button_data
   * @return mixed
   */
  public static function getButtonLabel($params = [], $button_data = []) {
    if (isset($button_data['label'])) {
      return $button_data['label'];
    }
    else {
      return t('Button');
    }
  }

  /**
   * @param array $params
   * @param array $button_data
   * @return array
   */
  public static function getButtonDashboardContent($params = [], $button_data = []) {
    return ['#markup' => t('Dashboard')];
  }

}
